CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

obj
  io:    "CogOS_IO(Term)"
  rndm:  "RealRandom"

pub DeepDiver | tmp
  io.start( 0, 0 )
  rndm.start

  ' wait until any key has been pushed
  tmp:=-1
  repeat while tmp==-1
    io.str( string( "Snake",$0d,"== please press key to start ==",$0d ) )
    tmp:=io.rxtime( 1000 )

  io.tx( 0 )
  io.tx( 1 )
  io.str( string("Welcome to Snake!",$0d) )
  io.str( string("Please set the terminal window to full size and after that press a key again!") )
  io.rx

  printFrame
  printAt( 5,5, string("And now, resize the window as you like") )
  printAt( 8,6, string("but showing the square and the score!") )
  printAt( 7,8, string(".. and press a key to start") )
  printScore
  printAt( 7,10, string("Use a,s,w,y for left, right, up, down") )
  printAt( 7,11, string(" ... enjoy ;o)") )
  io.rx

  'start key-COG
  cognew( readKey, @stack )

  repeat
    printFrame
     
    head := 0
    tail := 998
    size := 1
    snake[head] := 25
    snake[head+1] := 13
    dx := -1
    dy := 0
     
    gameLoop := 1   
    repeat while gameLoop
      headx := snake[head]
      heady := snake[head+1]
     
      head := head + 2
      if head==1000
        head:=0
      oldtail := tail
      tail := tail + 2
      if tail==1000
        tail:=0
     
      if kflag==1
        dx := kdx
        dy := kdy
        kflag := 0
        
      headx := headx + dx
      heady := heady + dy
     
      snake[ head ] := headx
      snake[ head+1 ] := heady
     
      check
      printSnake
      printTarget
      printScore
      
      waitcnt( clkfreq/8 + cnt )
     
    kflag:=1
    repeat 5
      printAt( 5,13, string( "Game over!" ) )
      waitcnt( clkfreq/4+cnt )
      printAt( 5,13, string( "          " ) )
      waitcnt( clkfreq/4+cnt )
    printAt( 5,13, string( "Game over!" ) )
     
    io.rx
     
pub check | i,pos
  if headx==0 or headx==49 or heady==0 or heady==26
    gameLoop:=0

  if size>5
    pos := head
    repeat i from 1 to 5
      pos := pos - 2
      if pos<0
        pos:=998      
    repeat i from 5 to size
      if headx==snake[ pos ] and heady==snake[pos+1]
        gameLoop:=0
        return
      pos := pos - 2
      if pos<0
        pos := 998
        
  if headx==targetx and heady==targety
    tail := oldtail
    tcounter := 0
    targetx := 0
    targety := 0
    size++
    score += 100

pub charAt( x,y,c )
  if x>0 and x<49 and y>0 and y<26 and c>31 and c<128
    posbuf[1]:=x
    posbuf[2]:=y
    posbuf[3]:=c
    io.str(@posbuf)

pub printAt( x, y, text)
  posbuf[1]:=x
  posbuf[2]:=y
  posbuf[3]:=0
  io.str(@posbuf)
  io.str( text )
        
dat
posbuf byte 2, 0, 0, 0, 0
      
pub printTarget
  if tcounter==0
    charAt( targetx, targety, space )
      
    tcounter := 100
    targetx := (rndm.random & $ff // 48) + 1
    targety := (rndm.random & $ff // 24) + 1

    charAt( targetx, targety, "X" )
    
  tcounter--
  
pub readKey | in
  repeat
    repeat while kflag == 1
    in := io.rx
    case in
        97:
          if dx<>1
            kdx := -1
            kdy := 0
            kflag := 1
        115:
          if dx<>-1
            kdx := 1
            kdy := 0
            kflag := 1
        121:
          if dy<>-1
            kdx := 0
            kdy := 1
            kflag := 1
        119:
          if dy<>1
            kdx := 0
            kdy := -1
            kflag := 1
    
pub printSnake
  charAt( snake[ head ], snake[ head+1 ], stars )
  charAt( snake[ tail ], snake[ tail+1 ], space )
      
VAR
  long oldLeft, oldRight, left, right, score, tcounter
  word head,tail,oldtail,size, gameLoop
  byte snake[1000]
  byte headx, heady
  byte targetx, targety
  byte dx, dy, kdx, kdy, kflag

  long stack[200]
  
pub printScore
  printAt( 55,1, string( "Score: " ) )
  dec( score )
    
pub printFrame
  io.tx( 0 )
  io.tx( 1 )
  io.str( @stars )
  score:=0
  repeat 25
    io.tx( $0d )
    io.tx( "*" )
    io.str( 2+@space )
    io.tx( "*" )
  io.tx( $0d )
  io.str( @stars )
    
PUB dec( val ) | i
  i:=10
  if val>0
    repeat while val<>0
      i--
      num[i]:="0"+val//10
      val:=val/10
  else
    io.tx( "0" )

  io.str( (10-i)+@zero )
  io.str( @num+i )
  
dat
num  byte 0[11]
zero byte "000000",0  
    
DAT
stars byte "**************************************************",0
space byte "                                                  ",0